]> arthur.barton.de Git - ngircd-alex.git/blobdiff - src/testsuite/stress-server.sh
ngIRCd Release 27
[ngircd-alex.git] / src / testsuite / stress-server.sh
index bf7ed00ff43dcaea421b24a8c9d64f3be91241b6..a9ef50763919fe7c3635a687b53a0b7f9c8f8ae1 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 #
 # ngIRCd Test Suite
-# Copyright (c)2002-2004 by Alexander Barton (alex@barton.de)
+# Copyright (c)2001-2024 Alexander Barton (alex@barton.de) and Contributors.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -9,70 +9,80 @@
 # (at your option) any later version.
 # Please read the file COPYING, README and AUTHORS for more information.
 #
-# $Id: stress-server.sh,v 1.11 2004/09/04 15:45:27 alex Exp $
-#
-
-# detect source directory
-[ -z "$srcdir" ] && srcdir=`dirname $0`
 
 # parse command line
-[ "$1" -gt 0 ] 2> /dev/null && CLIENTS="$1" || CLIENTS=5
-[ "$2" -gt 0 ] 2> /dev/null && MAX="$2" || MAX=5
+[ "$1" -gt 0 ] 2>/dev/null && CLIENTS="$1" || CLIENTS=5
+[ "$2" -gt 0 ] 2>/dev/null && MAX="$2" || MAX=-1
+
+# detect source directory
+[ -z "$srcdir" ] && srcdir=`dirname "$0"`
+set -u
 
 # get our name
-name=`basename $0`
+name=`basename "$0"`
 
 # create directories
-mkdir -p logs tests
+[ -d logs ] || mkdir logs
+[ -d tests ] || mkdir tests
 
 # test for required external tools
-type expect > /dev/null 2>&1
+type expect >/dev/null 2>&1
 if [ $? -ne 0 ]; then
-  echo "      ${name}: \"expect\" not found.";  exit 77
+       echo "${name}: \"expect\" not found."
+       exit 77
 fi
-type telnet > /dev/null 2>&1
+type telnet >/dev/null 2>&1
 if [ $? -ne 0 ]; then
-  echo "      ${name}: \"telnet\" not found.";  exit 77
+       echo "${name}: \"telnet\" not found.";
+       exit 77
 fi
 
 # hello world! :-)
-echo "      stressing server with $CLIENTS clients (be patient!):"
+echo "stressing server with $CLIENTS clients (be patient!):"
+
+# read in functions
+. "${srcdir}/functions.inc"
 
 # create scripts for expect(1)
 no=0
 while [ ${no} -lt $CLIENTS ]; do
-  cat ${srcdir}/stress-A.e > tests/${no}.e
-  echo "send \"nick test${no}\\r\"" >> tests/${no}.e
-  cat ${srcdir}/stress-B.e >> tests/${no}.e
-  no=`expr ${no} + 1`
+       cat "${srcdir}/stress-A.e" >tests/${no}.e
+       echo "send \"nick test${no}\\r\"" >>tests/${no}.e
+       cat "${srcdir}/stress-B.e" >>tests/${no}.e
+       no=`expr ${no} + 1`
 done
 
+# run first script and check if it succeeds
+echo_n "checking stress script ..."
+expect tests/0.e >logs/stress-0.log 2>/dev/null
+if [ $? -ne 0 ]; then
+       echo " failure!"
+       exit 1
+else
+       echo " ok."
+fi
+
 no=0
 while [ ${no} -lt $CLIENTS ]; do
-  expect tests/${no}.e > logs/stress-${no}.log 2> /dev/null &
-  no=`expr ${no} + 1`
+       expect tests/${no}.e >logs/stress-${no}.log 2>/dev/null &
 
-  count=`ps | grep "expect " | wc -l`
-  count=`expr $count - 1`
-  echo "      started client $no/$CLIENTS ($count test scripts running)."
+       no=`expr ${no} + 1`
+       echo "started client $no/$CLIENTS."
 
-  $srcdir/wait-tests.sh $MAX
+       [ $MAX -gt 0 ] && "$srcdir/wait-tests.sh" $MAX
 done
 
-echo -n "      waiting for clients to complete: ."
+echo_n "waiting for clients to complete: ."
 touch logs/check-idle.log
 while true; do
-  expect ${srcdir}/check-idle.e >> logs/check-idle.log; res=$?
-  echo "====================" >> logs/check-idle.log
-  [ $res -ne 99 ] && break
+       expect "${srcdir}/check-idle.e" >>logs/check-idle.log; res=$?
+       echo "====================" >>logs/check-idle.log
+       [ $res -ne 99 ] && break
 
-  # there are still clients connected. Wait ...
-  sleep 3
-  echo -n "."
+       # there are still clients connected. Wait ...
+       sleep 3
+       echo_n "."
 done
 
-[ $res -eq 0 ] && echo " done." || echo " ERROR!"
-
+[ $res -eq 0 ] && echo " ok." || echo " failure!"
 exit $res
-
-# -eof-